Update.
[platform/upstream/glibc.git] / elf / ldd.bash.in
1 #! @BASH@
2
3 # Copyright (C) 1996, 1997, 1998 Free Software Foundation, Inc.
4 # This file is part of the GNU C Library.
5
6 # The GNU C Library is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU Library General Public License as
8 # published by the Free Software Foundation; either version 2 of the
9 # License, or (at your option) any later version.
10
11 # The GNU C Library is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
14 # Library General Public License for more details.
15
16 # You should have received a copy of the GNU Library General Public
17 # License along with the GNU C Library; see the file COPYING.LIB.  If not,
18 # write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
19 # Boston, MA 02111-1307, USA.
20
21
22 # This is the `ldd' command, which lists what shared libraries are
23 # used by given dynamically-linked executables.  It works by invoking the
24 # run-time dynamic linker as a command and setting the environment
25 # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
26
27 # We should be able to find the translation right at the beginning.
28 TEXTDOMAIN=libc
29 TEXTDOMAINDIR=@TEXTDOMAINDIR@
30
31 RTLD=@RTLD@
32 warn=
33 bind_now=
34 verbose=
35
36 while test $# -gt 0; do
37   case "$1" in
38   --vers | --versi | --versio | --version)
39     echo 'ldd (GNU libc) @VERSION@'
40     echo $"Copyright (C) 1996, 1997, 1998 Free Software Foundation, Inc.
41 This is free software; see the source for copying conditions.  There is NO
42 warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
43 Written by Roland McGrath and Ulrich Drepper."
44     exit 0
45     ;;
46   --h | --he | --hel | --help)
47     echo $"ldd [OPTION]... FILE...
48       --help              print this help and exit
49       --version           print version information and exit
50   -d, --data-relocs       process data relocations
51   -r, --function-relocs   process data and function relocations
52   -v, --verbose           print all information
53 Report bugs using the \`glibcbug' script to <bugs@gnu.org>."
54     exit 0
55     ;;
56   -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
57   --data-rel | --data-relo | --data-reloc | --data-relocs)
58     warn=yes
59     shift
60     ;;
61   -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
62   --function | --function- | --function-r | --function-re | --function-rel | \
63   --function-relo | --function-reloc | --function-relocs)
64     warn=yes
65     bind_now=yes
66     shift
67     ;;
68   -v | --verb | --verbo | --verbos | --verbose)
69     verbose=yes
70     shift
71     ;;
72   --v | --ve | --ver)
73     echo >&2 $"ldd: option \`$1' is ambiguous"
74     exit 1
75     ;;
76   --)           # Stop option processing.
77     shift; break
78     ;;
79   -*)
80     echo >&2 'ldd:' $"unrecognized option" "\`$1'"
81     echo >&2 $"Try \`ldd --help' for more information."
82     exit 1
83     ;;
84   *)
85     break
86     ;;
87   esac
88 done
89
90 nonelf ()
91 {
92   # Maybe extra code for non-ELF binaries.
93   return 1;
94 }
95
96 add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
97 add_env="$add_env LD_VERBOSE=$verbose"
98 case $# in
99 0)
100   echo >&2 'ldd:' $"missing file arguments"
101   echo >&2 $"Try \`ldd --help' for more information."
102   exit 1
103   ;;
104 1)
105   # We don't list the file name when there is only one.
106   case "$1" in
107   */*) file="$1"
108        ;;
109   *) file="./$1"
110      ;;
111   esac
112   if test ! -f "$file"; then
113     echo "ldd: ${file}:" $"no such file"
114     exit 1
115   elif test -r "$file"; then
116     test -x "$file" ||
117     echo 'ldd:' $"warning: you do not have execution permission for" "\`$file'"
118     ${RTLD} --verify "$file"
119     case $? in
120     0)
121       eval $add_env exec '"$file"' || exit 1
122       ;;
123     1)
124       # This can be a non-ELF binary or no binary at all.
125       nonelf $file ||
126       echo $"   not a dynamic executable"
127       exit 1
128       ;;
129     2)
130       eval $add_env exec \${RTLD} '"$file"' || exit 1
131       ;;
132     *)
133       echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($?)" >&2
134       exit 1
135       ;;
136     esac
137   else
138     echo 'ldd:' $"error: you do not have read permission for" "\`$file'"
139     exit 1
140   fi
141   exit
142   ;;
143 *)
144   result=0
145   for file; do
146     echo "${file}:"
147     case "$file" in
148     */*) :
149          ;;
150     *) file="./$file"
151        ;;
152     esac
153     if test ! -f "$file"; then
154       echo "ldd: ${file}:" $"no such file"
155       result=1
156     elif test -r "$file"; then
157       test -x "$file" || echo 'ldd:' $"\
158 warning: you do not have execution permission for" "\`$file'"
159       ${RTLD} --verify "$file"
160       case $? in
161       0)
162         eval $add_env '"$file"' || result=1
163         ;;
164       1)
165         # This can be a non-ELF binary or no binary at all.
166         nonelf $file || {
167           echo $"       not a dynamic executable"
168           result=1
169         }
170         ;;
171       2)
172         eval $add_env ${RTLD} '"$file"' || result=1
173         ;;
174       *)
175         echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($?)" >&2
176         exit 1
177         ;;
178       esac
179     else
180       echo 'ldd:' $"error: you do not have read permission for" "\`$file'"
181       result=1
182     fi
183   done
184 esac
185
186 exit $result
187 # Local Variables:
188 #  mode:ksh
189 # End: